/* Generated by re2c 1.1.1 on Mon Dec 10 14:50:15 2018 */
#line 1 "src/parser_scan.re"
/*******************************************************************************
 Copyright (c) 2016, Michael Wallner <mike@php.net>.
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

     * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#ifdef HAVE_CONFIG_H
# include "config.h"
#else
# include "php_config.h"
#endif

#include "parser.h"
#include "plist.h"
#include "debug.h"

#define YYMAXFILL 15

#ifndef YYMAXFILL
# define YYMAXFILL 256
#endif

size_t psi_parser_maxfill(void) {
	return YYMAXFILL;
}

#define NEWLINE() \
	eol = cur; \
	++lines

#define NEWTOKEN(t) do { \
	if (t == PSI_T_COMMENT || t == PSI_T_WHITESPACE) { \
		token = psi_token_init(t, "", 0, tok - eol + 1, lines, I->file); \
	} else { \
		token = psi_token_init(t, tok, cur - tok, tok - eol + 1, lines, I->file); \
	} \
	tokens = psi_plist_add(tokens, &token); \
	PSI_DEBUG_LOCK(P, \
			PSI_DEBUG_PRINT(P, "PSI: scanned < "); \
			PSI_DEBUG_DUMP(P, psi_token_dump, token); \
	); \
} while(0)

#define CHECKEOF() if (cur >= lim - YYMAXFILL) goto done

struct psi_plist *psi_parser_scan(struct psi_parser *P, struct psi_parser_input *I)
{
	struct psi_plist *tokens;
	struct psi_token *token;
	const char *tok, *cur, *lim, *mrk, *eol, *ctxmrk;
	unsigned char_width, parens, lines = 1;
	bool escaped;

	PSI_DEBUG_PRINT(P, "PSI: scanning %s\n", I->file->val);

	tok = mrk = eol = cur = I->buffer;
	lim = I->buffer + I->length + YYMAXFILL;
	tokens = psi_plist_init((psi_plist_dtor) psi_token_free);

	start: ;
		char_width = 1;
		ctxmrk = NULL;
		tok = cur;

		(void) ctxmrk;

		
#line 90 "src/parser_scan.c"
		{
			unsigned char yych;
			unsigned int yyaccept = 0;
			if ((lim - cur) < 15) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\v':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case '@':
			case '`':
			case 0x7F:	goto yy2;
			case '\t':
			case '\f':
			case ' ':	goto yy4;
			case '\n':
			case '\r':	goto yy7;
			case '!':	goto yy9;
			case '"':	goto yy11;
			case '#':	goto yy13;
			case '$':	goto yy15;
			case '%':	goto yy16;
			case '&':	goto yy18;
			case '\'':	goto yy20;
			case '(':	goto yy22;
			case ')':	goto yy24;
			case '*':	goto yy26;
			case '+':	goto yy28;
			case ',':	goto yy30;
			case '-':	goto yy32;
			case '.':	goto yy34;
			case '/':	goto yy36;
			case '0':	goto yy38;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			case ':':	goto yy42;
			case ';':	goto yy44;
			case '<':	goto yy46;
			case '=':	goto yy48;
			case '>':	goto yy50;
			case '?':	goto yy52;
			case 'A':
			case 'a':	goto yy54;
			case 'B':	goto yy56;
			case 'C':	goto yy57;
			case 'D':	goto yy58;
			case 'E':	goto yy59;
			case 'F':	goto yy60;
			case 'I':	goto yy63;
			case 'L':	goto yy64;
			case 'M':
			case 'm':	goto yy65;
			case 'N':
			case 'n':	goto yy66;
			case 'O':
			case 'o':	goto yy67;
			case 'P':	goto yy68;
			case 'R':
			case 'r':	goto yy69;
			case 'S':	goto yy70;
			case 'T':	goto yy71;
			case 'U':	goto yy72;
			case 'W':
			case 'w':	goto yy73;
			case 'Z':
			case 'z':	goto yy74;
			case '[':	goto yy75;
			case '\\':	goto yy77;
			case ']':	goto yy79;
			case '^':	goto yy81;
			case '_':	goto yy83;
			case 'b':	goto yy84;
			case 'c':	goto yy85;
			case 'd':	goto yy86;
			case 'e':	goto yy87;
			case 'f':	goto yy88;
			case 'i':	goto yy89;
			case 'l':	goto yy90;
			case 'p':	goto yy91;
			case 's':	goto yy92;
			case 't':	goto yy93;
			case 'u':	goto yy94;
			case 'v':	goto yy95;
			case '{':	goto yy96;
			case '|':	goto yy98;
			case '}':	goto yy100;
			case '~':	goto yy102;
			default:	goto yy61;
			}
yy2:
			++cur;
yy3:
#line 253 "src/parser_scan.re"
			{ CHECKEOF(); NEWTOKEN(-2); goto error; }
#line 217 "src/parser_scan.c"
yy4:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy4;
			default:	goto yy6;
			}
yy6:
#line 252 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_WHITESPACE); goto start; }
#line 231 "src/parser_scan.c"
yy7:
			++cur;
#line 251 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_EOL); NEWLINE(); goto start; }
#line 236 "src/parser_scan.c"
yy9:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy104;
			default:	goto yy10;
			}
yy10:
#line 156 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NOT); goto start; }
#line 246 "src/parser_scan.c"
yy11:
			++cur;
#line 129 "src/parser_scan.re"
			{ escaped = false; tok += 1; goto string; }
#line 251 "src/parser_scan.c"
yy13:
			yych = *++cur;
			switch (yych) {
			case '#':	goto yy106;
			default:	goto yy14;
			}
yy14:
#line 139 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_HASH); goto start; }
#line 261 "src/parser_scan.c"
yy15:
			yych = *++cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy3;
			default:	goto yy108;
			}
yy16:
			++cur;
#line 157 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_MODULO); goto start; }
#line 336 "src/parser_scan.c"
yy18:
			yych = *++cur;
			switch (yych) {
			case '&':	goto yy111;
			default:	goto yy19;
			}
yy19:
#line 158 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_AMPERSAND); goto start; }
#line 346 "src/parser_scan.c"
yy20:
			++cur;
#line 128 "src/parser_scan.re"
			{ escaped = false; tok += 1; goto character; }
#line 351 "src/parser_scan.c"
yy22:
			++cur;
#line 140 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LPAREN); goto start; }
#line 356 "src/parser_scan.c"
yy24:
			++cur;
#line 141 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RPAREN); goto start; }
#line 361 "src/parser_scan.c"
yy26:
			++cur;
#line 154 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ASTERISK); goto start; }
#line 366 "src/parser_scan.c"
yy28:
			++cur;
#line 159 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PLUS); goto start; }
#line 371 "src/parser_scan.c"
yy30:
			++cur;
#line 143 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COMMA); goto start; }
#line 376 "src/parser_scan.c"
yy32:
			++cur;
#line 160 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_MINUS); goto start; }
#line 381 "src/parser_scan.c"
yy34:
			yyaccept = 0;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy113;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			default:	goto yy35;
			}
yy35:
#line 171 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PERIOD); goto start; }
#line 402 "src/parser_scan.c"
yy36:
			yych = *++cur;
			switch (yych) {
			case '*':	goto yy118;
			case '/':	goto yy120;
			default:	goto yy37;
			}
yy37:
#line 161 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SLASH); goto start; }
#line 413 "src/parser_scan.c"
yy38:
			yyaccept = 1;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy122;
			case 'E':
			case 'e':	goto yy126;
			case 'X':
			case 'x':	goto yy131;
			default:	goto yy125;
			}
yy39:
#line 115 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT; goto start; }
#line 428 "src/parser_scan.c"
yy40:
			yyaccept = 1;
			mrk = ++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '.':	goto yy122;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			case 'E':
			case 'e':	goto yy126;
			case 'L':
			case 'l':	goto yy127;
			case 'U':
			case 'u':	goto yy129;
			default:	goto yy39;
			}
yy42:
			++cur;
#line 144 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COLON); goto start; }
#line 458 "src/parser_scan.c"
yy44:
			++cur;
#line 142 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_EOS); goto start; }
#line 463 "src/parser_scan.c"
yy46:
			yyaccept = 2;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy132;
			case '<':	goto yy134;
			case '=':	goto yy136;
			default:	goto yy47;
			}
yy47:
#line 169 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LCHEVR); goto start; }
#line 541 "src/parser_scan.c"
yy48:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy138;
			default:	goto yy49;
			}
yy49:
#line 153 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_EQUALS); goto start; }
#line 551 "src/parser_scan.c"
yy50:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy140;
			case '>':	goto yy142;
			default:	goto yy51;
			}
yy51:
#line 170 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RCHEVR); goto start; }
#line 562 "src/parser_scan.c"
yy52:
			++cur;
#line 173 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IIF); goto start; }
#line 567 "src/parser_scan.c"
yy54:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy144;
			case 'S':
			case 's':	goto yy145;
			default:	goto yy62;
			}
yy55:
#line 246 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NAME); goto start; }
#line 581 "src/parser_scan.c"
yy56:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy148;
			default:	goto yy62;
			}
yy57:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy149;
			case 'O':
			case 'o':	goto yy150;
			default:	goto yy62;
			}
yy58:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy151;
			default:	goto yy62;
			}
yy59:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy152;
			case 'N':
			case 'n':	goto yy153;
			case 'R':
			case 'r':	goto yy154;
			default:	goto yy62;
			}
yy60:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy155;
			case 'L':
			case 'l':	goto yy156;
			case 'R':
			case 'r':	goto yy157;
			case 'U':
			case 'u':	goto yy158;
			default:	goto yy62;
			}
yy61:
			yyaccept = 3;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
yy62:
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy63:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy159;
			case 'N':
			case 'n':	goto yy161;
			default:	goto yy62;
			}
yy64:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy162;
			case 'E':
			case 'e':	goto yy164;
			default:	goto yy62;
			}
yy65:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy165;
			default:	goto yy62;
			}
yy66:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy166;
			default:	goto yy62;
			}
yy67:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy167;
			default:	goto yy62;
			}
yy68:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy168;
			case 'O':
			case 'o':	goto yy169;
			case 'R':
			case 'r':	goto yy170;
			default:	goto yy62;
			}
yy69:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy171;
			default:	goto yy62;
			}
yy70:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy172;
			case 'T':
			case 't':	goto yy173;
			default:	goto yy62;
			}
yy71:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy174;
			case 'O':
			case 'o':	goto yy175;
			case 'R':
			case 'r':	goto yy176;
			default:	goto yy62;
			}
yy72:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy177;
			case 'N':
			case 'n':	goto yy179;
			default:	goto yy62;
			}
yy73:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy180;
			default:	goto yy62;
			}
yy74:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy181;
			default:	goto yy62;
			}
yy75:
			++cur;
#line 147 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LBRACKET); goto start; }
#line 824 "src/parser_scan.c"
yy77:
			yych = *++cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy78;
			default:	goto yy182;
			}
yy78:
#line 162 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_BSLASH); goto start; }
#line 908 "src/parser_scan.c"
yy79:
			++cur;
#line 148 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RBRACKET); goto start; }
#line 913 "src/parser_scan.c"
yy81:
			++cur;
#line 164 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CARET); goto start; }
#line 918 "src/parser_scan.c"
yy83:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy185;
			default:	goto yy62;
			}
yy84:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy148;
			case 'o':	goto yy186;
			default:	goto yy62;
			}
yy85:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy149;
			case 'O':	goto yy150;
			case 'h':	goto yy187;
			case 'o':	goto yy188;
			default:	goto yy62;
			}
yy86:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy151;
			case 'o':	goto yy189;
			default:	goto yy62;
			}
yy87:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy152;
			case 'N':	goto yy153;
			case 'R':
			case 'r':	goto yy154;
			case 'n':	goto yy190;
			default:	goto yy62;
			}
yy88:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy155;
			case 'L':	goto yy156;
			case 'R':
			case 'r':	goto yy157;
			case 'U':
			case 'u':	goto yy158;
			case 'l':	goto yy191;
			default:	goto yy62;
			}
yy89:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy159;
			case 'N':	goto yy161;
			case 'n':	goto yy192;
			default:	goto yy62;
			}
yy90:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy164;
			case 'i':	goto yy193;
			case 'o':	goto yy194;
			default:	goto yy62;
			}
yy91:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy168;
			case 'O':
			case 'o':	goto yy169;
			case 'R':	goto yy170;
			case 'r':	goto yy195;
			default:	goto yy62;
			}
yy92:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy172;
			case 'T':	goto yy173;
			case 'h':	goto yy196;
			case 'i':	goto yy197;
			case 't':	goto yy198;
			default:	goto yy62;
			}
yy93:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy174;
			case 'O':
			case 'o':	goto yy175;
			case 'R':
			case 'r':	goto yy176;
			case 'y':	goto yy199;
			default:	goto yy62;
			}
yy94:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy200;
			case '8':	goto yy202;
			case 'N':	goto yy179;
			case 'n':	goto yy203;
			default:	goto yy62;
			}
yy95:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy204;
			default:	goto yy62;
			}
yy96:
			++cur;
#line 145 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LBRACE); goto start; }
#line 1059 "src/parser_scan.c"
yy98:
			yych = *++cur;
			switch (yych) {
			case '|':	goto yy205;
			default:	goto yy99;
			}
yy99:
#line 163 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PIPE); goto start; }
#line 1069 "src/parser_scan.c"
yy100:
			++cur;
#line 146 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RBRACE); goto start; }
#line 1074 "src/parser_scan.c"
yy102:
			++cur;
#line 155 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TILDE); goto start; }
#line 1079 "src/parser_scan.c"
yy104:
			++cur;
#line 149 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_NE); goto start; }
#line 1084 "src/parser_scan.c"
yy106:
			++cur;
#line 138 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_PASTE); goto start; }
#line 1089 "src/parser_scan.c"
yy108:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy110;
			default:	goto yy108;
			}
yy110:
#line 248 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DOLLAR_NAME); goto start; }
#line 1165 "src/parser_scan.c"
yy111:
			++cur;
#line 151 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_AND); goto start; }
#line 1170 "src/parser_scan.c"
yy113:
			yych = *++cur;
			switch (yych) {
			case '.':	goto yy207;
			default:	goto yy114;
			}
yy114:
			cur = mrk;
			switch (yyaccept) {
			case 0: 	goto yy35;
			case 1: 	goto yy39;
			case 2: 	goto yy47;
			case 3: 	goto yy55;
			case 4: 	goto yy117;
			case 5: 	goto yy128;
			case 6: 	goto yy146;
			case 7: 	goto yy160;
			case 8: 	goto yy184;
			case 9: 	goto yy241;
			case 10: 	goto yy250;
			case 11: 	goto yy271;
			case 12: 	goto yy303;
			case 13: 	goto yy305;
			case 14: 	goto yy311;
			case 15: 	goto yy319;
			case 16: 	goto yy331;
			case 17: 	goto yy339;
			case 18: 	goto yy343;
			case 19: 	goto yy350;
			case 20: 	goto yy352;
			case 21: 	goto yy356;
			case 22: 	goto yy360;
			case 23: 	goto yy362;
			case 24: 	goto yy372;
			case 25: 	goto yy375;
			case 26: 	goto yy382;
			case 27: 	goto yy385;
			case 28: 	goto yy387;
			case 29: 	goto yy389;
			case 30: 	goto yy393;
			case 31: 	goto yy398;
			case 32: 	goto yy416;
			case 33: 	goto yy419;
			case 34: 	goto yy424;
			case 35: 	goto yy427;
			case 36: 	goto yy431;
			case 37: 	goto yy437;
			case 38: 	goto yy441;
			case 39: 	goto yy446;
			case 40: 	goto yy448;
			case 41: 	goto yy452;
			case 42: 	goto yy455;
			case 43: 	goto yy457;
			case 44: 	goto yy459;
			case 45: 	goto yy464;
			case 46: 	goto yy466;
			case 47: 	goto yy468;
			case 48: 	goto yy470;
			case 49: 	goto yy472;
			case 50: 	goto yy477;
			case 51: 	goto yy486;
			case 52: 	goto yy488;
			case 53: 	goto yy490;
			case 54: 	goto yy492;
			case 55: 	goto yy494;
			case 56: 	goto yy496;
			case 57: 	goto yy501;
			case 58: 	goto yy505;
			case 59: 	goto yy509;
			case 60: 	goto yy511;
			case 61: 	goto yy516;
			case 62: 	goto yy521;
			case 63: 	goto yy527;
			case 64: 	goto yy531;
			case 65: 	goto yy533;
			case 66: 	goto yy535;
			case 67: 	goto yy537;
			case 68: 	goto yy542;
			case 69: 	goto yy544;
			case 70: 	goto yy551;
			case 71: 	goto yy553;
			case 72: 	goto yy558;
			case 73: 	goto yy560;
			case 74: 	goto yy567;
			case 75: 	goto yy571;
			case 76: 	goto yy574;
			case 77: 	goto yy578;
			default:	goto yy583;
			}
yy115:
			yyaccept = 4;
			mrk = ++cur;
			if ((lim - cur) < 2) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			case 'D':
			case 'd':	goto yy209;
			case 'F':
			case 'f':	goto yy210;
			case 'L':
			case 'l':	goto yy212;
			default:	goto yy117;
			}
yy117:
#line 121 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT; goto start; }
#line 1287 "src/parser_scan.c"
yy118:
			++cur;
#line 135 "src/parser_scan.re"
			{ goto comment; }
#line 1292 "src/parser_scan.c"
yy120:
			++cur;
#line 136 "src/parser_scan.re"
			{ goto comment_sl; }
#line 1297 "src/parser_scan.c"
yy122:
			yyaccept = 4;
			mrk = ++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy122;
			case 'D':
			case 'd':	goto yy209;
			case 'E':
			case 'e':	goto yy126;
			case 'F':
			case 'f':	goto yy210;
			case 'L':
			case 'l':	goto yy212;
			default:	goto yy117;
			}
yy124:
			++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
yy125:
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':	goto yy124;
			case 'L':
			case 'l':	goto yy127;
			case 'U':
			case 'u':	goto yy129;
			default:	goto yy39;
			}
yy126:
			yych = *++cur;
			switch (yych) {
			case '+':
			case '-':	goto yy214;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			default:	goto yy114;
			}
yy127:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy215;
			case 'U':
			case 'u':	goto yy216;
			default:	goto yy128;
			}
yy128:
			cur -= 1;
#line 117 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_L; cur += 1; goto start; }
#line 1375 "src/parser_scan.c"
yy129:
			yych = *++cur;
			switch (yych) {
			case 'L':
			case 'l':	goto yy218;
			default:	goto yy130;
			}
yy130:
			cur -= 1;
#line 116 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_U; cur += 1; goto start; }
#line 1387 "src/parser_scan.c"
yy131:
			yych = *++cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy219;
			default:	goto yy114;
			}
yy132:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy132;
			case '>':	goto yy221;
			default:	goto yy114;
			}
yy134:
			++cur;
#line 165 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LSHIFT); goto start; }
#line 1493 "src/parser_scan.c"
yy136:
			++cur;
#line 167 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_LE); goto start; }
#line 1498 "src/parser_scan.c"
yy138:
			++cur;
#line 150 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_EQ); goto start; }
#line 1503 "src/parser_scan.c"
yy140:
			++cur;
#line 168 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CMP_GE); goto start; }
#line 1508 "src/parser_scan.c"
yy142:
			++cur;
#line 166 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RSHIFT); goto start; }
#line 1513 "src/parser_scan.c"
yy144:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy223;
			default:	goto yy62;
			}
yy145:
			yyaccept = 6;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy146;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy146:
#line 226 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_AS); goto start; }
#line 1596 "src/parser_scan.c"
yy147:
			++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy114;
			default:	goto yy182;
			}
yy148:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy224;
			default:	goto yy62;
			}
yy149:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy225;
			default:	goto yy62;
			}
yy150:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy226;
			default:	goto yy62;
			}
yy151:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy227;
			default:	goto yy62;
			}
yy152:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy228;
			case 'S':
			case 's':	goto yy229;
			default:	goto yy62;
			}
yy153:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy230;
			default:	goto yy62;
			}
yy154:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy231;
			default:	goto yy62;
			}
yy155:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy232;
			default:	goto yy62;
			}
yy156:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy233;
			default:	goto yy62;
			}
yy157:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy234;
			default:	goto yy62;
			}
yy158:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy235;
			default:	goto yy62;
			}
yy159:
			yyaccept = 7;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy160;
			case 'D':
			case 'd':	goto yy236;
			case 'N':
			case 'n':	goto yy237;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy160:
#line 197 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IF); goto start; }
#line 1847 "src/parser_scan.c"
yy161:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy238;
			case 'T':
			case 't':	goto yy239;
			default:	goto yy62;
			}
yy162:
			++cur;
			cur -= 1;
#line 133 "src/parser_scan.re"
			{ char_width = sizeof(wchar_t); }
#line 1863 "src/parser_scan.c"
yy164:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy240;
			default:	goto yy62;
			}
yy165:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'X':
			case 'x':	goto yy242;
			default:	goto yy62;
			}
yy166:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy243;
			default:	goto yy62;
			}
yy167:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'J':
			case 'j':	goto yy244;
			default:	goto yy62;
			}
yy168:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy245;
			default:	goto yy62;
			}
yy169:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy246;
			default:	goto yy62;
			}
yy170:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy247;
			default:	goto yy62;
			}
yy171:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy248;
			default:	goto yy62;
			}
yy172:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy249;
			default:	goto yy62;
			}
yy173:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy251;
			case 'R':
			case 'r':	goto yy252;
			default:	goto yy62;
			}
yy174:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'M':
			case 'm':	goto yy253;
			default:	goto yy62;
			}
yy175:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy254;
			default:	goto yy62;
			}
yy176:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy255;
			default:	goto yy62;
			}
yy177:
			++cur;
			cur -= 1;
#line 132 "src/parser_scan.re"
			{ char_width = 4; }
#line 1974 "src/parser_scan.c"
yy179:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy256;
			default:	goto yy62;
			}
yy180:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy257;
			default:	goto yy62;
			}
yy181:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy258;
			default:	goto yy62;
			}
yy182:
			yyaccept = 8;
			mrk = ++cur;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy184;
			case '\\':	goto yy147;
			default:	goto yy182;
			}
yy184:
#line 247 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NSNAME); goto start; }
#line 2075 "src/parser_scan.c"
yy185:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy259;
			case 'e':	goto yy260;
			case 'i':	goto yy261;
			case 'r':	goto yy262;
			default:	goto yy62;
			}
yy186:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy224;
			case 'o':	goto yy263;
			default:	goto yy62;
			}
yy187:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy264;
			default:	goto yy62;
			}
yy188:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy226;
			case 'n':	goto yy265;
			default:	goto yy62;
			}
yy189:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'u':	goto yy266;
			default:	goto yy62;
			}
yy190:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy230;
			case 'u':	goto yy267;
			default:	goto yy62;
			}
yy191:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy233;
			case 'o':	goto yy268;
			default:	goto yy62;
			}
yy192:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy238;
			case 'T':	goto yy239;
			case 'l':	goto yy269;
			case 't':	goto yy270;
			default:	goto yy62;
			}
yy193:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy272;
			default:	goto yy62;
			}
yy194:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy273;
			default:	goto yy62;
			}
yy195:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy247;
			case 'a':	goto yy274;
			default:	goto yy62;
			}
yy196:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy275;
			default:	goto yy62;
			}
yy197:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy276;
			case 'z':	goto yy277;
			default:	goto yy62;
			}
yy198:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy251;
			case 'R':	goto yy252;
			case 'r':	goto yy278;
			default:	goto yy62;
			}
yy199:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'p':	goto yy279;
			default:	goto yy62;
			}
yy200:
			++cur;
			cur -= 1;
#line 131 "src/parser_scan.re"
			{ char_width = 2; }
#line 2205 "src/parser_scan.c"
yy202:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':	goto yy280;
			default:	goto yy62;
			}
yy203:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy256;
			case 'i':	goto yy282;
			case 's':	goto yy283;
			default:	goto yy62;
			}
yy204:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy284;
			case 'l':	goto yy285;
			default:	goto yy62;
			}
yy205:
			++cur;
#line 152 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_OR); goto start; }
#line 2235 "src/parser_scan.c"
yy207:
			++cur;
#line 172 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ELLIPSIS); goto start; }
#line 2240 "src/parser_scan.c"
yy209:
			yych = *++cur;
			switch (yych) {
			case 'D':
			case 'd':	goto yy286;
			case 'F':
			case 'f':	goto yy288;
			case 'L':
			case 'l':	goto yy290;
			default:	goto yy114;
			}
yy210:
			++cur;
			cur -= 1;
#line 122 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_F; cur += 1; goto start; }
#line 2257 "src/parser_scan.c"
yy212:
			++cur;
			cur -= 1;
#line 123 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_L; cur += 1; goto start; }
#line 2263 "src/parser_scan.c"
yy214:
			yych = *++cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy115;
			default:	goto yy114;
			}
yy215:
			yych = *++cur;
			switch (yych) {
			case 'U':
			case 'u':	goto yy292;
			default:	goto yy114;
			}
yy216:
			++cur;
yy217:
			cur -= 2;
#line 118 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_UL; cur += 2; goto start; }
#line 2292 "src/parser_scan.c"
yy218:
			yych = *++cur;
			switch (yych) {
			case 'L':
			case 'l':	goto yy292;
			default:	goto yy217;
			}
yy219:
			yyaccept = 1;
			mrk = ++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '.':	goto yy294;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy219;
			case 'L':
			case 'l':	goto yy127;
			case 'P':
			case 'p':	goto yy126;
			case 'U':
			case 'u':	goto yy129;
			default:	goto yy39;
			}
yy221:
			++cur;
#line 249 "src/parser_scan.re"
			{ tok += 1; cur -= 1; NEWTOKEN(PSI_T_CPP_HEADER); cur += 1; goto start; }
#line 2341 "src/parser_scan.c"
yy223:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy296;
			case 'V':
			case 'v':	goto yy297;
			default:	goto yy62;
			}
yy224:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy298;
			default:	goto yy62;
			}
yy225:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy299;
			default:	goto yy62;
			}
yy226:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy300;
			default:	goto yy62;
			}
yy227:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy301;
			default:	goto yy62;
			}
yy228:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy302;
			default:	goto yy62;
			}
yy229:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy304;
			default:	goto yy62;
			}
yy230:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy306;
			default:	goto yy62;
			}
yy231:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy307;
			default:	goto yy62;
			}
yy232:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy308;
			default:	goto yy62;
			}
yy233:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy309;
			default:	goto yy62;
			}
yy234:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy310;
			default:	goto yy62;
			}
yy235:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy312;
			default:	goto yy62;
			}
yy236:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy313;
			default:	goto yy62;
			}
yy237:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy314;
			default:	goto yy62;
			}
yy238:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy315;
			default:	goto yy62;
			}
yy239:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy316;
			default:	goto yy62;
			}
yy240:
			yyaccept = 9;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy241;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy241:
#line 221 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LET); goto start; }
#line 2554 "src/parser_scan.c"
yy242:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy317;
			default:	goto yy62;
			}
yy243:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy318;
			default:	goto yy62;
			}
yy244:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy320;
			case 'V':
			case 'v':	goto yy321;
			default:	goto yy62;
			}
yy245:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'H':
			case 'h':	goto yy322;
			default:	goto yy62;
			}
yy246:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy323;
			default:	goto yy62;
			}
yy247:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy324;
			default:	goto yy62;
			}
yy248:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy325;
			default:	goto yy62;
			}
yy249:
			yyaccept = 10;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy250;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy250:
#line 222 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SET); goto start; }
#line 2686 "src/parser_scan.c"
yy251:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy326;
			default:	goto yy62;
			}
yy252:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy327;
			case 'L':
			case 'l':	goto yy328;
			case 'V':
			case 'v':	goto yy329;
			default:	goto yy62;
			}
yy253:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'P':
			case 'p':	goto yy330;
			default:	goto yy62;
			}
yy254:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy332;
			case 'B':
			case 'b':	goto yy333;
			case 'F':
			case 'f':	goto yy334;
			case 'I':
			case 'i':	goto yy335;
			case 'O':
			case 'o':	goto yy336;
			case 'S':
			case 's':	goto yy337;
			default:	goto yy62;
			}
yy255:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy338;
			default:	goto yy62;
			}
yy256:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy340;
			default:	goto yy62;
			}
yy257:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy341;
			default:	goto yy62;
			}
yy258:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy342;
			default:	goto yy62;
			}
yy259:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy344;
			case 't':	goto yy345;
			default:	goto yy62;
			}
yy260:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'x':	goto yy346;
			default:	goto yy62;
			}
yy261:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy347;
			default:	goto yy62;
			}
yy262:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy348;
			default:	goto yy62;
			}
yy263:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':	goto yy298;
			case 'l':	goto yy349;
			default:	goto yy62;
			}
yy264:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy351;
			default:	goto yy62;
			}
yy265:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy353;
			default:	goto yy62;
			}
yy266:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'b':	goto yy354;
			default:	goto yy62;
			}
yy267:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy355;
			default:	goto yy62;
			}
yy268:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':	goto yy309;
			case 'a':	goto yy357;
			default:	goto yy62;
			}
yy269:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy358;
			default:	goto yy62;
			}
yy270:
			yyaccept = 11;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy271;
			case 'V':
			case 'v':	goto yy316;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy271:
#line 191 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INT); goto start; }
#line 2921 "src/parser_scan.c"
yy272:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy359;
			default:	goto yy62;
			}
yy273:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy361;
			default:	goto yy62;
			}
yy274:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy363;
			default:	goto yy62;
			}
yy275:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy364;
			default:	goto yy62;
			}
yy276:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy365;
			default:	goto yy62;
			}
yy277:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy366;
			default:	goto yy62;
			}
yy278:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy327;
			case 'L':
			case 'l':	goto yy328;
			case 'V':
			case 'v':	goto yy329;
			case 'u':	goto yy367;
			default:	goto yy62;
			}
yy279:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy368;
			default:	goto yy62;
			}
yy280:
			++cur;
			cur -= 1;
#line 130 "src/parser_scan.re"
			{ char_width = 1; }
#line 2989 "src/parser_scan.c"
yy282:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy369;
			default:	goto yy62;
			}
yy283:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy370;
			default:	goto yy62;
			}
yy284:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy371;
			default:	goto yy62;
			}
yy285:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy373;
			default:	goto yy62;
			}
yy286:
			++cur;
			cur -= 2;
#line 125 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DD; cur += 2; goto start; }
#line 3023 "src/parser_scan.c"
yy288:
			++cur;
			cur -= 2;
#line 124 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DF; cur += 2; goto start; }
#line 3029 "src/parser_scan.c"
yy290:
			++cur;
			cur -= 2;
#line 126 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DL; cur += 2; goto start; }
#line 3035 "src/parser_scan.c"
yy292:
			++cur;
			cur -= 3;
#line 119 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_ULL; cur += 3; goto start; }
#line 3041 "src/parser_scan.c"
yy294:
			++cur;
			if ((lim - cur) < 3) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy294;
			case 'P':
			case 'p':	goto yy126;
			default:	goto yy114;
			}
yy296:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'Y':
			case 'y':	goto yy374;
			default:	goto yy62;
			}
yy297:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy376;
			default:	goto yy62;
			}
yy298:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy377;
			default:	goto yy62;
			}
yy299:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy378;
			case 'B':
			case 'b':	goto yy379;
			case 'O':
			case 'o':	goto yy380;
			default:	goto yy62;
			}
yy300:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy381;
			default:	goto yy62;
			}
yy301:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy383;
			default:	goto yy62;
			}
yy302:
			yyaccept = 12;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy303;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy303:
#line 201 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ELIF); goto start; }
#line 3199 "src/parser_scan.c"
yy304:
			yyaccept = 13;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy305;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy305:
#line 200 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ELSE); goto start; }
#line 3274 "src/parser_scan.c"
yy306:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy384;
			default:	goto yy62;
			}
yy307:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy386;
			default:	goto yy62;
			}
yy308:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy388;
			default:	goto yy62;
			}
yy309:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy390;
			default:	goto yy62;
			}
yy310:
			yyaccept = 14;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy311;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy311:
#line 227 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FREE); goto start; }
#line 3381 "src/parser_scan.c"
yy312:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy391;
			default:	goto yy62;
			}
yy313:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy392;
			default:	goto yy62;
			}
yy314:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy394;
			default:	goto yy62;
			}
yy315:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy395;
			default:	goto yy62;
			}
yy316:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy396;
			default:	goto yy62;
			}
yy317:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy397;
			default:	goto yy62;
			}
yy318:
			yyaccept = 15;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy319;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy319:
#line 212 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_NULL); goto start; }
#line 3504 "src/parser_scan.c"
yy320:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy399;
			default:	goto yy62;
			}
yy321:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy400;
			default:	goto yy62;
			}
yy322:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy401;
			default:	goto yy62;
			}
yy323:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy402;
			default:	goto yy62;
			}
yy324:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy403;
			default:	goto yy62;
			}
yy325:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy404;
			default:	goto yy62;
			}
yy326:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy405;
			default:	goto yy62;
			}
yy327:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy406;
			default:	goto yy62;
			}
yy328:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy407;
			default:	goto yy62;
			}
yy329:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy408;
			default:	goto yy62;
			}
yy330:
			yyaccept = 16;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy331;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy331:
#line 228 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TEMP); goto start; }
#line 3658 "src/parser_scan.c"
yy332:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy409;
			default:	goto yy62;
			}
yy333:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy410;
			default:	goto yy62;
			}
yy334:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy411;
			default:	goto yy62;
			}
yy335:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy412;
			default:	goto yy62;
			}
yy336:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy413;
			default:	goto yy62;
			}
yy337:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy414;
			default:	goto yy62;
			}
yy338:
			yyaccept = 17;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy339;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy339:
#line 210 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TRUE); goto start; }
#line 3781 "src/parser_scan.c"
yy340:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy415;
			default:	goto yy62;
			}
yy341:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy417;
			default:	goto yy62;
			}
yy342:
			yyaccept = 18;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy343;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy343:
#line 237 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ZVAL); goto start; }
#line 3872 "src/parser_scan.c"
yy344:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy418;
			default:	goto yy62;
			}
yy345:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy420;
			default:	goto yy62;
			}
yy346:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy421;
			default:	goto yy62;
			}
yy347:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy269;
			default:	goto yy62;
			}
yy348:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy422;
			default:	goto yy62;
			}
yy349:
			yyaccept = 19;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy350;
			case 'V':
			case 'v':	goto yy377;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy350:
#line 188 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_BOOL); goto start; }
#line 3984 "src/parser_scan.c"
yy351:
			yyaccept = 20;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy352;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy352:
#line 189 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CHAR); goto start; }
#line 4059 "src/parser_scan.c"
yy353:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy423;
			default:	goto yy62;
			}
yy354:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy425;
			default:	goto yy62;
			}
yy355:
			yyaccept = 21;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy356;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy356:
#line 185 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ENUM); goto start; }
#line 4148 "src/parser_scan.c"
yy357:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':	goto yy390;
			case 't':	goto yy426;
			default:	goto yy62;
			}
yy358:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy428;
			default:	goto yy62;
			}
yy359:
			yyaccept = 22;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy360;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy360:
#line 181 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LINE); goto start; }
#line 4238 "src/parser_scan.c"
yy361:
			yyaccept = 23;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy362;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy362:
#line 192 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_LONG); goto start; }
#line 4313 "src/parser_scan.c"
yy363:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy429;
			default:	goto yy62;
			}
yy364:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy430;
			default:	goto yy62;
			}
yy365:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy432;
			default:	goto yy62;
			}
yy366:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy433;
			default:	goto yy62;
			}
yy367:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'c':	goto yy434;
			default:	goto yy62;
			}
yy368:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy435;
			default:	goto yy62;
			}
yy369:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy436;
			default:	goto yy62;
			}
yy370:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy438;
			default:	goto yy62;
			}
yy371:
			yyaccept = 24;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy372;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy372:
#line 187 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_VOID); goto start; }
#line 4444 "src/parser_scan.c"
yy373:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy439;
			default:	goto yy62;
			}
yy374:
			yyaccept = 25;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy375;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy375:
#line 216 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ARRAY); goto start; }
#line 4526 "src/parser_scan.c"
yy376:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy440;
			default:	goto yy62;
			}
yy377:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy442;
			default:	goto yy62;
			}
yy378:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy443;
			default:	goto yy62;
			}
yy379:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy444;
			default:	goto yy62;
			}
yy380:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy445;
			default:	goto yy62;
			}
yy381:
			yyaccept = 26;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy382;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy382:
#line 238 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COUNT); goto start; }
#line 4641 "src/parser_scan.c"
yy383:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy447;
			default:	goto yy62;
			}
yy384:
			yyaccept = 27;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy385;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy385:
#line 202 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ENDIF); goto start; }
#line 4724 "src/parser_scan.c"
yy386:
			yyaccept = 28;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy387;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy387:
#line 207 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ERROR); goto start; }
#line 4799 "src/parser_scan.c"
yy388:
			yyaccept = 29;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy389;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy389:
#line 211 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FALSE); goto start; }
#line 4874 "src/parser_scan.c"
yy390:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy449;
			default:	goto yy62;
			}
yy391:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy450;
			default:	goto yy62;
			}
yy392:
			yyaccept = 30;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy393;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy393:
#line 198 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IFDEF); goto start; }
#line 4965 "src/parser_scan.c"
yy394:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy451;
			default:	goto yy62;
			}
yy395:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy453;
			default:	goto yy62;
			}
yy396:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy454;
			default:	goto yy62;
			}
yy397:
			yyaccept = 31;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy398;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy398:
#line 213 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_MIXED); goto start; }
#line 5064 "src/parser_scan.c"
yy399:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy456;
			default:	goto yy62;
			}
yy400:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy458;
			default:	goto yy62;
			}
yy401:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy460;
			default:	goto yy62;
			}
yy402:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy461;
			default:	goto yy62;
			}
yy403:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy462;
			default:	goto yy62;
			}
yy404:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy463;
			default:	goto yy62;
			}
yy405:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy465;
			default:	goto yy62;
			}
yy406:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy467;
			default:	goto yy62;
			}
yy407:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy469;
			default:	goto yy62;
			}
yy408:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy471;
			default:	goto yy62;
			}
yy409:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy473;
			default:	goto yy62;
			}
yy410:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy474;
			default:	goto yy62;
			}
yy411:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy475;
			default:	goto yy62;
			}
yy412:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy476;
			default:	goto yy62;
			}
yy413:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'J':
			case 'j':	goto yy478;
			default:	goto yy62;
			}
yy414:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy479;
			default:	goto yy62;
			}
yy415:
			yyaccept = 32;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy416;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy416:
#line 205 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_UNDEF); goto start; }
#line 5267 "src/parser_scan.c"
yy417:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy480;
			default:	goto yy62;
			}
yy418:
			yyaccept = 33;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy419;
			case '\\':	goto yy147;
			case '_':	goto yy481;
			default:	goto yy61;
			}
yy419:
#line 178 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_ASM); goto start; }
#line 5351 "src/parser_scan.c"
yy420:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy482;
			default:	goto yy62;
			}
yy421:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy483;
			default:	goto yy62;
			}
yy422:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy484;
			default:	goto yy62;
			}
yy423:
			yyaccept = 34;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy424;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy424:
#line 186 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CONST); goto start; }
#line 5447 "src/parser_scan.c"
yy425:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy485;
			default:	goto yy62;
			}
yy426:
			yyaccept = 35;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy427;
			case 'V':
			case 'v':	goto yy449;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy427:
#line 193 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FLOAT); goto start; }
#line 5531 "src/parser_scan.c"
yy428:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy487;
			default:	goto yy62;
			}
yy429:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy489;
			default:	goto yy62;
			}
yy430:
			yyaccept = 36;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy431;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy431:
#line 190 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SHORT); goto start; }
#line 5620 "src/parser_scan.c"
yy432:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy491;
			default:	goto yy62;
			}
yy433:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'f':	goto yy493;
			default:	goto yy62;
			}
yy434:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy495;
			default:	goto yy62;
			}
yy435:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy497;
			default:	goto yy62;
			}
yy436:
			yyaccept = 37;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy437;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy437:
#line 184 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_UNION); goto start; }
#line 5723 "src/parser_scan.c"
yy438:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy498;
			default:	goto yy62;
			}
yy439:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy499;
			default:	goto yy62;
			}
yy440:
			yyaccept = 38;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy441;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy441:
#line 235 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_ARRVAL); goto start; }
#line 5812 "src/parser_scan.c"
yy442:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy500;
			default:	goto yy62;
			}
yy443:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy502;
			default:	goto yy62;
			}
yy444:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy503;
			default:	goto yy62;
			}
yy445:
			yyaccept = 39;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy446;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy446:
#line 239 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CALLOC); goto start; }
#line 5911 "src/parser_scan.c"
yy447:
			yyaccept = 40;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy448;
			case 'D':
			case 'd':	goto yy504;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy448:
#line 203 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DEFINE); goto start; }
#line 5988 "src/parser_scan.c"
yy449:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy506;
			default:	goto yy62;
			}
yy450:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy507;
			default:	goto yy62;
			}
yy451:
			yyaccept = 41;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy452;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy452:
#line 199 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_IFNDEF); goto start; }
#line 6079 "src/parser_scan.c"
yy453:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy508;
			default:	goto yy62;
			}
yy454:
			yyaccept = 42;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy455;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy455:
#line 232 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INTVAL); goto start; }
#line 6162 "src/parser_scan.c"
yy456:
			yyaccept = 43;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy457;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy457:
#line 217 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_OBJECT); goto start; }
#line 6237 "src/parser_scan.c"
yy458:
			yyaccept = 44;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy459;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy459:
#line 236 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_OBJVAL); goto start; }
#line 6312 "src/parser_scan.c"
yy460:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy510;
			default:	goto yy62;
			}
yy461:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy512;
			default:	goto yy62;
			}
yy462:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy513;
			default:	goto yy62;
			}
yy463:
			yyaccept = 45;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy464;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy464:
#line 225 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_RETURN); goto start; }
#line 6411 "src/parser_scan.c"
yy465:
			yyaccept = 46;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy466;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy466:
#line 219 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STATIC); goto start; }
#line 6486 "src/parser_scan.c"
yy467:
			yyaccept = 47;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy468;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy468:
#line 215 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRING); goto start; }
#line 6561 "src/parser_scan.c"
yy469:
			yyaccept = 48;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy470;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy470:
#line 229 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRLEN); goto start; }
#line 6636 "src/parser_scan.c"
yy471:
			yyaccept = 49;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy472;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy472:
#line 230 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRVAL); goto start; }
#line 6711 "src/parser_scan.c"
yy473:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy514;
			default:	goto yy62;
			}
yy474:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy515;
			default:	goto yy62;
			}
yy475:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy517;
			default:	goto yy62;
			}
yy476:
			yyaccept = 50;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy477;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy477:
#line 243 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_INT); goto start; }
#line 6810 "src/parser_scan.c"
yy478:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy518;
			default:	goto yy62;
			}
yy479:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy519;
			default:	goto yy62;
			}
yy480:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy520;
			default:	goto yy62;
			}
yy481:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy522;
			default:	goto yy62;
			}
yy482:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy523;
			default:	goto yy62;
			}
yy483:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy524;
			default:	goto yy62;
			}
yy484:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy525;
			default:	goto yy62;
			}
yy485:
			yyaccept = 51;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy486;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy486:
#line 194 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DOUBLE); goto start; }
#line 6937 "src/parser_scan.c"
yy487:
			yyaccept = 52;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy488;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy488:
#line 175 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_INLINE); goto start; }
#line 7012 "src/parser_scan.c"
yy489:
			yyaccept = 53;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy490;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy490:
#line 174 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PRAGMA); goto start; }
#line 7087 "src/parser_scan.c"
yy491:
			yyaccept = 54;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy492;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy492:
#line 196 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SIGNED); goto start; }
#line 7162 "src/parser_scan.c"
yy493:
			yyaccept = 55;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy494;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy494:
#line 180 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_SIZEOF); goto start; }
#line 7237 "src/parser_scan.c"
yy495:
			yyaccept = 56;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy496;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy496:
#line 183 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_STRUCT); goto start; }
#line 7312 "src/parser_scan.c"
yy497:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'f':	goto yy526;
			default:	goto yy62;
			}
yy498:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy528;
			default:	goto yy62;
			}
yy499:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy529;
			default:	goto yy62;
			}
yy500:
			yyaccept = 57;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy501;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy501:
#line 234 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_BOOLVAL); goto start; }
#line 7408 "src/parser_scan.c"
yy502:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy530;
			default:	goto yy62;
			}
yy503:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'K':
			case 'k':	goto yy532;
			default:	goto yy62;
			}
yy504:
			yyaccept = 58;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy505;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy505:
#line 204 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_DEFINED); goto start; }
#line 7499 "src/parser_scan.c"
yy506:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy534;
			default:	goto yy62;
			}
yy507:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy536;
			default:	goto yy62;
			}
yy508:
			yyaccept = 59;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy509;
			case '\\':	goto yy147;
			case '_':	goto yy538;
			default:	goto yy61;
			}
yy509:
#line 208 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INCLUDE); goto start; }
#line 7591 "src/parser_scan.c"
yy510:
			yyaccept = 60;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy511;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy511:
#line 231 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PATHVAL); goto start; }
#line 7666 "src/parser_scan.c"
yy512:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy539;
			default:	goto yy62;
			}
yy513:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy540;
			default:	goto yy62;
			}
yy514:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'Y':
			case 'y':	goto yy541;
			default:	goto yy62;
			}
yy515:
			yyaccept = 61;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy516;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy516:
#line 245 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_BOOL); goto start; }
#line 7765 "src/parser_scan.c"
yy517:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy543;
			default:	goto yy62;
			}
yy518:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy545;
			default:	goto yy62;
			}
yy519:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy546;
			default:	goto yy62;
			}
yy520:
			yyaccept = 62;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy521;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy521:
#line 206 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_WARNING); goto start; }
#line 7864 "src/parser_scan.c"
yy522:
			yyaccept = 33;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy419;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy523:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'b':	goto yy547;
			default:	goto yy62;
			}
yy524:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy548;
			default:	goto yy62;
			}
yy525:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy549;
			default:	goto yy62;
			}
yy526:
			yyaccept = 63;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy527;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy527:
#line 182 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TYPEDEF); goto start; }
#line 8031 "src/parser_scan.c"
yy528:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy550;
			default:	goto yy62;
			}
yy529:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy552;
			default:	goto yy62;
			}
yy530:
			yyaccept = 64;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy531;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy531:
#line 214 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CALLABLE); goto start; }
#line 8120 "src/parser_scan.c"
yy532:
			yyaccept = 65;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy533;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy533:
#line 218 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CALLBACK); goto start; }
#line 8195 "src/parser_scan.c"
yy534:
			yyaccept = 66;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy535;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy535:
#line 233 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FLOATVAL); goto start; }
#line 8270 "src/parser_scan.c"
yy536:
			yyaccept = 67;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy537;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy537:
#line 220 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_FUNCTION); goto start; }
#line 8345 "src/parser_scan.c"
yy538:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy554;
			default:	goto yy62;
			}
yy539:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy555;
			default:	goto yy62;
			}
yy540:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy556;
			default:	goto yy62;
			}
yy541:
			yyaccept = 68;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy542;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy542:
#line 241 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_ARRAY); goto start; }
#line 8444 "src/parser_scan.c"
yy543:
			yyaccept = 69;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy544;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy544:
#line 244 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_FLOAT); goto start; }
#line 8519 "src/parser_scan.c"
yy545:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy557;
			default:	goto yy62;
			}
yy546:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy559;
			default:	goto yy62;
			}
yy547:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'u':	goto yy561;
			default:	goto yy62;
			}
yy548:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy562;
			default:	goto yy62;
			}
yy549:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'c':	goto yy563;
			default:	goto yy62;
			}
yy550:
			yyaccept = 70;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy551;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy551:
#line 195 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_UNSIGNED); goto start; }
#line 8631 "src/parser_scan.c"
yy552:
			yyaccept = 71;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy553;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy553:
#line 179 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_VOLATILE); goto start; }
#line 8706 "src/parser_scan.c"
yy554:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy564;
			default:	goto yy62;
			}
yy555:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy565;
			default:	goto yy62;
			}
yy556:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy566;
			default:	goto yy62;
			}
yy557:
			yyaccept = 72;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy558;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy558:
#line 240 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_OBJECT); goto start; }
#line 8805 "src/parser_scan.c"
yy559:
			yyaccept = 73;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy560;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy560:
#line 242 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_TO_STRING); goto start; }
#line 8880 "src/parser_scan.c"
yy561:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy568;
			default:	goto yy62;
			}
yy562:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy569;
			default:	goto yy62;
			}
yy563:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy570;
			default:	goto yy62;
			}
yy564:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'X':
			case 'x':	goto yy572;
			default:	goto yy62;
			}
yy565:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy573;
			default:	goto yy62;
			}
yy566:
			yyaccept = 74;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy567;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy567:
#line 223 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_PRE_ASSERT); goto start; }
#line 8992 "src/parser_scan.c"
yy568:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy575;
			default:	goto yy62;
			}
yy569:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy576;
			default:	goto yy62;
			}
yy570:
			yyaccept = 75;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy571;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy571:
#line 176 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_RESTRICT); goto start; }
#line 9081 "src/parser_scan.c"
yy572:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy577;
			default:	goto yy62;
			}
yy573:
			yyaccept = 76;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy574;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy574:
#line 224 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_POST_ASSERT); goto start; }
#line 9164 "src/parser_scan.c"
yy575:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy579;
			default:	goto yy62;
			}
yy576:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy580;
			default:	goto yy62;
			}
yy577:
			yyaccept = 77;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy578;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy578:
#line 209 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_INCLUDE_NEXT); goto start; }
#line 9253 "src/parser_scan.c"
yy579:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy581;
			default:	goto yy62;
			}
yy580:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy582;
			default:	goto yy62;
			}
yy581:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy584;
			case '(':	goto yy586;
			default:	goto yy62;
			}
yy582:
			yyaccept = 78;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy583;
			case '\\':	goto yy147;
			default:	goto yy61;
			}
yy583:
#line 177 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_CPP_EXTENSION); goto start; }
#line 9352 "src/parser_scan.c"
yy584:
			++cur;
			if ((lim - cur) < 2) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy584;
			case '(':	goto yy586;
			default:	goto yy114;
			}
yy586:
			yych = *++cur;
			switch (yych) {
			case '(':	goto yy587;
			default:	goto yy114;
			}
yy587:
			++cur;
#line 250 "src/parser_scan.re"
			{ parens = 2; goto cpp_attribute; }
#line 9374 "src/parser_scan.c"
		}
#line 256 "src/parser_scan.re"


	character: ;
		
#line 9381 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy593;
			case '\'':	goto yy595;
			case '\\':	goto yy597;
			default:	goto yy591;
			}
yy591:
			++cur;
#line 274 "src/parser_scan.re"
			{ escaped = false; goto character; }
#line 9397 "src/parser_scan.c"
yy593:
			++cur;
#line 261 "src/parser_scan.re"
			{ NEWLINE(); goto character; }
#line 9402 "src/parser_scan.c"
yy595:
			++cur;
#line 263 "src/parser_scan.re"
			{
			if (escaped) {
				escaped = false;
				goto character;
			}
			cur -= 1;
			NEWTOKEN(PSI_T_QUOTED_CHAR);
			cur += 1;
			token->flags = char_width;
			goto start;
		}
#line 9417 "src/parser_scan.c"
yy597:
			++cur;
#line 262 "src/parser_scan.re"
			{ escaped = !escaped;  goto character; }
#line 9422 "src/parser_scan.c"
		}
#line 276 "src/parser_scan.re"


	string: ;
		
#line 9429 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy603;
			case '"':	goto yy605;
			case '\\':	goto yy607;
			default:	goto yy601;
			}
yy601:
			++cur;
#line 294 "src/parser_scan.re"
			{ escaped = false; goto string; }
#line 9445 "src/parser_scan.c"
yy603:
			++cur;
#line 281 "src/parser_scan.re"
			{ NEWLINE(); goto string; }
#line 9450 "src/parser_scan.c"
yy605:
			++cur;
#line 283 "src/parser_scan.re"
			{
			if (escaped) {
				escaped = false;
				goto string;
			}
			cur -= 1;
			NEWTOKEN(PSI_T_QUOTED_STRING);
			cur += 1;
			token->flags = char_width;
			goto start;
		}
#line 9465 "src/parser_scan.c"
yy607:
			++cur;
#line 282 "src/parser_scan.re"
			{ escaped = !escaped; goto string; }
#line 9470 "src/parser_scan.c"
		}
#line 296 "src/parser_scan.re"


	comment: ;
		
#line 9477 "src/parser_scan.c"
		{
			unsigned char yych;
			if ((lim - cur) < 2) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy613;
			case '*':	goto yy615;
			default:	goto yy611;
			}
yy611:
			++cur;
yy612:
#line 303 "src/parser_scan.re"
			{ goto comment; }
#line 9493 "src/parser_scan.c"
yy613:
			++cur;
#line 301 "src/parser_scan.re"
			{ NEWLINE(); goto comment; }
#line 9498 "src/parser_scan.c"
yy615:
			yych = *++cur;
			switch (yych) {
			case '/':	goto yy616;
			default:	goto yy612;
			}
yy616:
			++cur;
#line 302 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COMMENT); goto start; }
#line 9509 "src/parser_scan.c"
		}
#line 305 "src/parser_scan.re"


	comment_sl: ;
		
#line 9516 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy622;
			default:	goto yy620;
			}
yy620:
			++cur;
#line 311 "src/parser_scan.re"
			{ goto comment_sl; }
#line 9530 "src/parser_scan.c"
yy622:
			++cur;
#line 310 "src/parser_scan.re"
			{ NEWTOKEN(PSI_T_COMMENT); tok = cur - 1; NEWTOKEN(PSI_T_EOL); NEWLINE(); goto start; }
#line 9535 "src/parser_scan.c"
		}
#line 313 "src/parser_scan.re"


	cpp_attribute: ;

		
#line 9543 "src/parser_scan.c"
		{
			unsigned char yych;
			if (lim <= cur) CHECKEOF();;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy628;
			case '(':	goto yy630;
			case ')':	goto yy632;
			default:	goto yy626;
			}
yy626:
			++cur;
#line 322 "src/parser_scan.re"
			{ goto cpp_attribute; }
#line 9559 "src/parser_scan.c"
yy628:
			++cur;
#line 321 "src/parser_scan.re"
			{ NEWLINE(); goto cpp_attribute; }
#line 9564 "src/parser_scan.c"
yy630:
			++cur;
#line 319 "src/parser_scan.re"
			{ ++parens; goto cpp_attribute; }
#line 9569 "src/parser_scan.c"
yy632:
			++cur;
#line 320 "src/parser_scan.re"
			{ if (parens == 1) { NEWTOKEN(PSI_T_CPP_ATTRIBUTE); goto start; } else { --parens; goto cpp_attribute; } }
#line 9574 "src/parser_scan.c"
		}
#line 324 "src/parser_scan.re"

error: ;

	P->error(PSI_DATA(P), token, PSI_WARNING, "PSI syntax error: unexpected input (%d) '%.*s' at col %tu",
			token->type, token->text->len, token->text->val, tok - eol + 1);
	psi_plist_free(tokens);
	return NULL;

done: ;

	PSI_DEBUG_PRINT(P, "PSI: EOF cur=%p lim=%p\n", cur, lim);

	return tokens;
}
